

import random

liste_lettre_proposee = []

def liste_de_mot():
    """création d'une liste de mot à partir du fichier dico.txt
    sortie : list_mot (list)
    """
    #ouverture du fichier dico.txt en lecture (r) et au format texte (t)
    #et enregistrement dans la variable fichierLu
    fichier_lu = open('dico.txt', 'rt')
    #lecture des lignes pour créer une liste
    liste = fichier_lu.readlines()
    #fermeture du fichier
    fichier_lu.close()
    return liste

def liste_de_mot_propre(liste):
    """nettoie chaque mot de la liste du retour à la ligne (\n)
    et retourne la liste (liste_propre)
    entrée : liste (list)
    sortie : liste_propre (list)
    """

# assert liste_de_mot_propre(['REINE\n', 'ROI\n']) == ['REINE', 'ROI']


def choix_mot(liste):
    """retourne un mot (sous forme de liste) pris au hazard dans une liste
    entrée : liste (list)
    sortie : mot (list)
    """
    

def creation_mot_vide(mot):
    """création d'une liste de n caractères _ équal au nombre n constituant le mot
    entrée : mot (list)
    sortie : mot_a_completer (list)
    """

#assert creation_mot_vide(['R', 'O', 'I']) == ['-', '-', '-']

    
def complete_mot_a_trou(mot_mystere, mot_a_trou, lettre):
    """retourne mot à trou compléter avec la lettre à l'endroit ou elle se se situe dans le mot mystère
    entrée : mot_mystère (list)
    entrée : mot_a_trou (list)
    entrée : lettre (char)
    sortie : mot_a_trou (list)
    """

# assert complete_mot_a_trou(['R', 'O', 'I'], ['-', '-', '-'], 'O') == ['-', 'O', '-']
# assert complete_mot_a_trou(['R', 'O', 'I'], ['R', '-', '-'], 'O') == ['R', 'O', '-']
# assert complete_mot_a_trou(['R', 'E', 'I', 'N', 'E'], ['-', '-', '-', '-', '-'], 'E') == ['-', 'E', '-', '-', 'E']


def test_lettre_deja_proposee(liste_lettre_proposee, lettre):
    """test si la lettre proposée est contenu dans la liste des lettre proposée
    entrée : lettre_proposee (list)
    entrée : lettre (char)
    sortie : (boolean)
    """

# assert test_lettre_deja_proposee([], 'A') == False
# assert test_lettre_deja_proposee(['E', 'P'], 'A') == False
# assert test_lettre_deja_proposee(['E', 'A', 'I', 'P'], 'I') == True


def test_lettre_dans_mot_a_trouver(mot_mystere, lettre):
    """test si la lettre proposée se situe dans le mot à trouver
    entrée : mot_mystere (list)
    entrée : lettre (char)
    sortie (boolean)
    """

# assert test_lettre_dans_mot_a_trouver(['R', 'E', 'I', 'N', 'E'], 'A') == False
# assert test_lettre_dans_mot_a_trouver(['R', 'E', 'I', 'N', 'E'], 'N') == True


def ajout_liste_lettre_proposee(liste_lettre_proposee, lettre):
    """ajoute à la liste des lettre proposée la nouvelle lettre
    entrée : liste_lettre_proposee (list)
    entrée : lettre (char)
    sortie : liste_lettre_proposee (list)
    """

# assert ajout_liste_lettre_proposee([], 'A') == ['A']
# assert ajout_liste_lettre_proposee(['E', 'P'], 'A') == ['E', 'P', 'A']


def gagne(mot_mystere, mot_a_trou):
    """test si le mot mystere est equal au mot a trou
    entrée : mot_mystere (list)
    entrée : mot_a_trou (list)
    sortie (boolean)
    """

# assert gagne(['R', 'E', 'I', 'N', 'E'], ['R', 'E', 'I', 'N', 'E']) == True
# assert gagne(['R', 'E', 'I', 'N', 'E'], ['-', '-', '-', '-', '-']) == False
# assert gagne(['R', 'E', 'I', 'N', 'E'], ['R', 'E', 'I', '-', 'E']) == False


def convertir_liste_chaine(liste):
    """convertie une liste de caractères en chaine de caractères
    entrée : liste (list)
    sortie : chaine (String)
    """

# assert convertir_liste_chaine(['R', 'E', 'I', 'N', 'E']) == 'REINE'
    

def dessin_pendu(nb):
    """renvoie une valeur du tableau correspondant à un dessin du pendu en fonction du nombre rentré
    entrée : nb (int)
    sortie : tab (String)
    """
    tab=[
    """
       +-------+
       |
       |
       |
       |
       |
    ==============
    """,
    """
       +-------+
       |       |
       |       O
       |
       |
       |
    ==============
    """
        ,
    """
       +-------+
       |       |
       |       O
       |       |
       |
       |
    ==============
    """,
    """
       +-------+
       |       |
       |       O
       |      -|
       |
       |
    ==============
    """,
    """
       +-------+
       |       |
       |       O
       |      -|-
       |
       |
    ==============
    """,
    """
       +-------+
       |       |
       |       O
       |      -|-
       |      |
       |
    ==============
    """,
    """
       +-------+
       |       |
       |       O
       |      -|-
       |      | |
       |
    ==============
    """
    ]
    return tab[nb]

"""
#Programme principal

##nombre de tentative fausse
nb = 0
#création d'une liste de mot à partir d'un fichier
list_word = liste_de_mot()
#nettoyage dela liste des mots (\n)
list_clean = liste_de_mot_propre(list_word)
#choix du mot mystere
mot_mystere = choix_mot(list_clean)
#création du mot à trou à partir du mot mystère
mot_a_trou = creation_mot_vide(mot_mystere)
print('JEU DU PENDU')
print()
win = False
perdu = False
while (win != True) and (perdu != True) :
    print(convertir_liste_chaine(mot_a_trou))
    print()
    test_deja_lettre = True
    while test_deja_lettre == True:
        lettre_proposee = input('Proposes une lettre : ')
        print(lettre_proposee)
        test_deja_lettre = test_lettre_deja_proposee(liste_lettre_proposee, lettre_proposee)
        if test_deja_lettre == True:
            print('La lettre a déjà été proposée !')
    ajout_liste_lettre_proposee(liste_lettre_proposee, lettre_proposee)
    lettre_trouvee = test_lettre_dans_mot_a_trouver(mot_mystere, lettre_proposee)
    if lettre_trouvee == True:
        mot_a_trou = complete_mot_a_trou(mot_mystere, mot_a_trou, lettre_proposee)
        win = gagne(mot_mystere, mot_a_trou)
    else:
        print(dessin_pendu(nb))
        nb+=1
        if nb == 7:
            perdu = True
print()
if win:
    print(convertir_liste_chaine(mot_a_trou))
    print('BRAVO')
else:
    print('PERDU')
    print(f'Le mot à trouver était : {convertir_liste_chaine(mot_mystere)}')
"""